---
title: Advanced Concepts
order: 2
sidebar_position: 2
---

# Advanced Concepts

## Build & Deployment

There are a variety of ways to host your Spectacle presentation.

1. If you are integrating this lib yourself, take your build and follow the linked instructions from any of (but not limited to) the following providers: [Heroku](https://devcenter.heroku.com/articles/git#deploying-code), [Zeit](https://zeit.co/docs/v2/platform/deployments), or [Surge](https://surge.sh/help/deploying-continuously-using-git-hooks).

2. If using `spectacle-cli` (either `spectacle --action build` or `spectacle-boilerplate` with `yarn clean && yarn build`) your output is `dist/` and upload that directory to any of the above static hosting providers.

## Keyboard Controls

| Key Combination | Function               |
| --------------- | ---------------------- |
| Right Arrow     | Next Slide             |
| Left Arrow      | Previous Slide         |
| Alt/Option + O  | Toggle Overview Mode   |
| Alt/Option + P  | Toggle Presenter Mode  |
| Alt/Option + F  | Toggle Fullscreen Mode |

## Query Parameters

A handful of query parameters are supported within your Spectacle presentation.
Append your URL with one of the following parameters, like so: `&<parameter>=true`.
To combine parameters, use multiple `&` to separate the parameters, e.g.: `&exportMode=true&printMode=true`

| Parameter       | Description of Use                                                                                                                                        |
| --------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `exportMode`    | For exporting your presentation as a PDF. Add it to your project URL and "Save to PDF" directly from the browser                                          |
| `printMode`     | Turns your slideshow into a printer-friendly, black & white version. Meant for use concurrently with `?exportMode` e.g. `?exportMode=true&printMode=true` |
| `presenterMode` | Displays a Presenter Mode for ease of presentation. For more info on this mode, please see [Presenting](./#presenting) in our Basic Concepts doc          |
